clear all

n=10000;
n=n+100;
% degrs de libert de la loi de Cauchy
nu=4.6;
% initialisation
m1=zeros(1,n);
m2=zeros(1,n);


% Mthode 1 : simulation suivant la loi de student
x=trnd(nu,1,n);


for i=1:n-100;
z=x(1:i+100);   
m1(i)=sum(exp(-z.^2))/(100+i);
end

test=gamrnd(nu/2,2/nu,1,n);
y=1./(test);
%x=randn(1,n).*sqrt(y);
% Mthode 2 : Rao-Blackwell
for i=1:n-100;
z=y(1:i+100);   
m2(i)=sum(1./sqrt(2*z+1))/(100+i);
end


% figure
figure
plot(m1(1:n-100))
hold on
plot(m2(1:n-100),'r')
plot(0.5373*ones(1,n-100),'k')
XLABEL('iterations')
YLABEL('intgrale')
legend('Estimateur usuel','Rao Blackwellization','Valeur de l''intgrale',0)
hold off
% print -depsc Raoblack




