% Gnration d'une loi normale 1D
% de moyenne m et d'ecart type sigma
%m=3;
m=0;
%sigma=sqrt(5);
sigma=sqrt(1);
sigma2=sigma^2;
N=5000;




% Initialisation (choix de l'espace d'tat Omega)
% N va uniformes sur m - 4*sigma, m + 4 * sigma

x=8*sigma*rand(1,N)-(4*sigma)+m;
xI=x;

% Metropolis Hastings Indpendants Nc iterations
Nc=100;
for j=1:Nc,
for i=1:N,
	% gnration 
 	inter=8*sigma*rand-(4*sigma)+m;
        % calcul de l'cart
	delta=((inter-m)^2-(xI(i)-m)^2)/(2*sigma2);
	% T=1 pour l'algorithme de Metropolis Hastings
	if (delta < 0.0 | exp(-delta)>rand)
		xI(i)=inter;
	end
end
end

% Metropolis Hastings Marche alatoire
% Loi de proposition uniforme sur [-d ; d]
d=1;
% d=0.1
x=2*d*rand(1,N)-d;
xMA=x;

for j=1:Nc,
for i=1:N,
	% gnration 
 	inter=2*d*rand-d;
    y=xMA(i)+inter;
        % calcul de l'cart
	delta=((y-m)^2-(xMA(i)-m)^2)/(2*sigma2);
	% T=1 pour l'algorithme de Metropolis Hastings
	if (delta < 0.0 | exp(-delta)>rand)
		xMA(i)=y;
	end
end
end

% affichage des resultats
% histogramme et loi cible - Metropolis Indpendant
% nombre de classes
figure(1)
nc=100;
y=linspace(min(xI),max(xI),nc);
normal=(max(xI)-min(xI))*N/nc;
plot(y,hist(xI,nc)/normal)
hold on
z = normpdf(y,m,sigma);
plot(y,z)
hold off

% histogramme et loi cible - Metropolis Marche Alatoire
figure(2)
y=linspace(min(xMA),max(xMA),nc);
normal=(max(xMA)-min(xMA))*N/nc;
plot(y,hist(xMA,nc)/normal)
hold on
z = normpdf(y,m,sigma);
plot(y,z)
hold off


